/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 4);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["i"] = triggerPixel;
/* harmony export (immutable) */ __webpack_exports__["a"] = createTrackPixelHtml;
/* harmony export (immutable) */ __webpack_exports__["j"] = writeAdUrl;
/* harmony export (immutable) */ __webpack_exports__["g"] = sendRequest;
/* harmony export (immutable) */ __webpack_exports__["d"] = getUUID;
/* harmony export (immutable) */ __webpack_exports__["e"] = loadScript;
/* harmony export (immutable) */ __webpack_exports__["b"] = getCreativeComment;
/* harmony export (immutable) */ __webpack_exports__["c"] = getCreativeCommentMarkup;
/* harmony export (immutable) */ __webpack_exports__["h"] = transformAuctionTargetingData;
/* harmony export (immutable) */ __webpack_exports__["f"] = parseUrl;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__domHelper__ = __webpack_require__(1);


/**
 * Inserts an image pixel with the specified `url` for cookie sync
 * @param {string} url URL string of the image pixel to load
 * @param  {function} [done] an optional exit callback, used when this usersync pixel is added during an async process
 */
function triggerPixel(url, done) {
  var img = new Image();
  if (done && typeof done === 'function') {
    img.addEventListener('load', done);
    img.addEventListener('error', done);
  }
  img.src = url;
}
function createTrackPixelHtml(url) {
  if (!url) {
    return '';
  }
  var escapedUrl = encodeURI(url);
  var img = "<div style=\"position:absolute;left:0px;top:0px;visibility:hidden;\"><img src=\"".concat(escapedUrl, "\"></div>");
  return img;
}
function writeAdUrl(adUrl, width, height) {
  var iframe = __WEBPACK_IMPORTED_MODULE_0__domHelper__["a" /* getEmptyIframe */](height, width);
  iframe.src = adUrl;
  document.body.appendChild(iframe);
}
function sendRequest(url, callback) {
  function reqListener() {
    callback(oReq.responseText);
  }
  var oReq = new XMLHttpRequest();
  oReq.addEventListener('load', reqListener);
  oReq.open('GET', url);
  oReq.send();
}
function getUUID() {
  var d = new Date().getTime();
  var uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
    var r = (d + Math.random() * 16) % 16 | 0;
    d = Math.floor(d / 16);
    return (c === 'x' ? r : r & 0x3 | 0x8).toString(16);
  });
  return uuid;
}
;
function loadScript(currentWindow, tagSrc, successCallback, errorCallback) {
  var doc = currentWindow.document;
  var scriptTag = doc.createElement('script');
  scriptTag.type = 'text/javascript';

  // Execute success callback if necessary
  if (successCallback && typeof successCallback === 'function') {
    if (scriptTag.readyState) {
      scriptTag.onreadystatechange = function () {
        if (scriptTag.readyState === 'loaded' || scriptTag.readyState === 'complete') {
          scriptTag.onreadystatechange = null;
          successCallback();
        }
      };
    } else {
      scriptTag.onload = function () {
        successCallback();
      };
    }
  }

  // Execute error callback if necessary
  if (errorCallback && typeof errorCallback === 'function') {
    scriptTag.onerror = function () {
      errorCallback();
    };
  }
  scriptTag.src = tagSrc;

  //add the new script tag to the page
  var elToAppend = doc.getElementsByTagName('head');
  elToAppend = elToAppend.length ? elToAppend : doc.getElementsByTagName('body');
  if (elToAppend.length) {
    elToAppend = elToAppend[0];
    elToAppend.insertBefore(scriptTag, elToAppend.firstChild);
  }
  return scriptTag;
}
;

/**
 * Return comment element
 * @param {*} bid
 */
function getCreativeComment(bid) {
  return document.createComment("Creative ".concat(bid.crid, " served by Prebid.js Header Bidding"));
}

/**
 * Returns comment element markup
 * @param {*} bid
 */
function getCreativeCommentMarkup(bid) {
  var creativeComment = getCreativeComment(bid);
  var wrapper = document.createElement('div');
  wrapper.appendChild(creativeComment);
  return wrapper.innerHTML;
}
function transformAuctionTargetingData(tagData) {
  // this map object translates the Prebid.js auction keys to their equivalent Prebid Universal Creative keys
  // when the publisher uses their adserver's generic macro that provides all targeting keys (ie tagData.targetingMap), we need to convert the keys
  var auctionKeyMap = {
    hb_adid: 'adId',
    hb_cache_host: 'cacheHost',
    hb_cache_path: 'cachePath',
    hb_cache_id: 'uuid',
    hb_format: 'mediaType',
    hb_env: 'env',
    hb_size: 'size',
    hb_pb: 'hbPb'
  };

  /**
   * Determine if the supplied property of the tagData object exists and is populated with its own values/properties according to its type
   * @param {string} paramName name of the property to check (eg tagData.targetingMap)
   * @returns true/false
   */
  function isMacroPresent(paramName) {
    return !!(tagData[paramName] && (isPlainObject(tagData[paramName]) && Object.keys(tagData[paramName]).length > 0 || isStr(tagData[paramName]) && tagData[paramName] !== ''));
  }

  /**
   * Converts the specifically formatted object of keypairs to a more generalized structure
   * It specifically extracts the keyvalue from an array and stores it as a normal string
   * @param {object} tarMap object of keys with the keyvalue stored in an array; eg {"hb_adid":["26566ee8c7f251"], ...}
   * @returns {object} result is an object map like the following: {"hb_cache_id":"123456", "other_key":"other_value", ...}
   */
  function convertTargetingMapToNormalMap(tarMap) {
    var newTarMap = {};
    Object.keys(tarMap).forEach(function (key) {
      if (Array.isArray(tarMap[key]) && tarMap[key].length > 0) {
        newTarMap[key] = tarMap[key][0];
      }
    });
    return newTarMap;
  }

  /**
   * Converts a specifically formatted string of keypairs to a specifically formatted object map
   * @param {String} keywordsStr string of keypairs; eg "hb_cache_id:123456,other_key:other_value"
   * @returns {object} result is an object map like the following: {"hb_cache_id":"123456", "other_key":"other_value", ...}
   */
  function convertKeyPairStringToMap(keywordsStr) {
    var keywordsMap = {};
    var keywordsArr = keywordsStr.split(',');
    if (keywordsArr.length > 0) {
      keywordsArr.forEach(function (keyPairStr) {
        var keyPairArr = keyPairStr.split(':');
        if (keyPairArr.length === 2) {
          var k = keyPairArr[0];
          var v = keyPairArr[1];
          keywordsMap[k] = v;
        }
      });
    }
    return keywordsMap;
  }

  /**
   * Rename key if it's part of the auctionKeyMap object; if not, leave key as is
   * Store the resultant keypair in the auctionData object for later use in renderingManager.renderAd()
   * @param {object} adServerKeyMap incoming object map of the auction keys from the UC tag; eg {'key1':'value1', 'key2':'value2', ...}
   */
  function renameKnownAuctionKeys(adServerKeyMap) {
    Object.keys(adServerKeyMap).forEach(function (key) {
      var internalKey = auctionKeyMap[key] || key;
      auctionData[internalKey] = adServerKeyMap[key];
    });
  }
  var auctionData = {};
  var formattedKeyMap = {};
  if (isMacroPresent('targetingMap')) {
    formattedKeyMap = convertTargetingMapToNormalMap(tagData.targetingMap);
  } else if (isMacroPresent('targetingKeywords')) {
    formattedKeyMap = convertKeyPairStringToMap(tagData.targetingKeywords);
  }
  renameKnownAuctionKeys(formattedKeyMap);

  // set keys not in defined map macros (eg targetingMap) and/or the keys setup within a non-DFP adserver
  Object.keys(tagData).forEach(function (key) {
    if (key !== 'targetingMap' && key !== 'targetingKeywords' && isStr(tagData[key]) && tagData[key] !== '') {
      auctionData[key] = tagData[key];
    }
  });
  return auctionData;
}
function parseUrl(url) {
  var parsed = document.createElement('a');
  parsed.href = decodeURIComponent(url);
  return {
    href: parsed.href,
    protocol: (parsed.protocol || '').replace(/:$/, ''),
    hostname: parsed.hostname,
    port: +parsed.port,
    pathname: parsed.pathname.replace(/^(?!\/)/, '/'),
    hash: (parsed.hash || '').replace(/^#/, ''),
    host: (parsed.host || window.location.host).replace(/:(443|80)$/, '')
  };
}
function isA(object, _t) {
  return Object.prototype.toString.call(object) === '[object ' + _t + ']';
}
;
function isPlainObject(object) {
  return isA(object, 'Object');
}
function isStr(object) {
  return isA(object, 'String');
}
;

/***/ }),
/* 1 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["c"] = makeIframe;
/* harmony export (immutable) */ __webpack_exports__["a"] = getEmptyIframe;
/* harmony export (immutable) */ __webpack_exports__["b"] = insertElement;
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }
function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
/**
 * domHelper: a collection of helpful dom things
 */

/**
 * returns a empty iframe element with specified attributes.
 */
function makeIframe(doc) {
  var attrs = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var frame = doc.createElement('iframe');
  Object.entries(_extends({
    frameborder: 0,
    scrolling: 'no',
    marginheight: 0,
    marginwidth: 0,
    TOPMARGIN: 0,
    LEFTMARGIN: 0,
    allowtransparency: 'true'
  }, attrs)).forEach(function (_ref) {
    var _ref2 = _slicedToArray(_ref, 2),
      attr = _ref2[0],
      value = _ref2[1];
    frame.setAttribute(attr, value);
  });
  return frame;
}

/**
 * returns a empty iframe element with specified height/width
 * @param {Number} height height iframe set to
 * @param {Number} width width iframe set to
 * @returns {Element} iframe DOM element
 */
function getEmptyIframe(height, width) {
  return makeIframe(document, {
    height: height,
    width: width
  });
}

/**
* Insert element to passed target
* @param {object} elm
* @param {object} doc
* @param {string} target
*/
function insertElement(elm, doc, target) {
  doc = doc || document;
  var elToAppend;
  if (target) {
    elToAppend = doc.getElementsByTagName(target);
  } else {
    elToAppend = doc.getElementsByTagName('head');
  }
  try {
    elToAppend = elToAppend.length ? elToAppend : doc.getElementsByTagName('body');
    if (elToAppend.length) {
      elToAppend = elToAppend[0];
      elToAppend.insertBefore(elm, elToAppend.firstChild);
    }
  } catch (e) {}
}

/***/ }),
/* 2 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["b"] = isAmp;
/* harmony export (immutable) */ __webpack_exports__["d"] = isSafeFrame;
/* unused harmony export isCrossDomain */
/* unused harmony export canInspectWindow */
/* harmony export (immutable) */ __webpack_exports__["a"] = canLocatePrebid;
/* harmony export (immutable) */ __webpack_exports__["c"] = isMobileApp;
/***************************************
 * Detect Environment Helper Functions
 ***************************************/

/**
 * Functions to detect below environments:
 *  Amp: google Accelerate Mobile Pages ampproject.org
 *  SafeFrame: SafeFrame
 *  CrossDomain: An iframe that can't get to the top window
 *  Mobile App: function to detect mobile app environment
 */

/**
 * @param {String} uuid key value from auction, contains the cache id of the winning bid stored in prebid cache
 * @returns true if there is an AMP context object
 */
function isAmp(uuid, win) {
  // TODO Use amp context once it is available in cross domain
  // https://github.com/ampproject/amphtml/issues/6829
  return typeof uuid === 'string' && uuid !== "" && isCrossDomain(win);
}

/**
 * @returns true if the environment is a SafeFrame.
 */
function isSafeFrame(win) {
  return !!(win.$sf && win.$sf.ext);
}

/**
  * Return true if we are in an iframe and can't access the top window.
  * @returns true if the environment is a Cross Domain
  */
function isCrossDomain(win) {
  return win.top !== win && !canInspectWindow(win);
}

/**
 * Returns true if win's properties can be accessed and win is defined.
 * This functioned is used to determine if a window is cross-domained
 * from the perspective of the current window.
 * @param {!Window} win
 * @return {boolean}
 */
function canInspectWindow(win) {
  try {
    // force an exception in x-domain environments. #1509
    win.top.location.toString();
    return true;
  } catch (e) {
    return false;
  }
}

/**
 * Returns true if we can find the prebid global object (eg pbjs) as we
 * climb the accessible windows.  Return false if it's not found.
 * @returns {boolean}
 */
function canLocatePrebid(win) {
  var result = false;
  var currentWindow = win;
  while (!result) {
    try {
      if (currentWindow.pbjs) {
        result = true;
        break;
      }
    } catch (e) {}
    if (currentWindow === window.top) break;
    currentWindow = currentWindow.parent;
  }
  return result;
}

/**
 * @param {String} env key value from auction, indicates the environment where tag is served
 * @returns true if env exists and is equal to the string 'mobile-app'
 */
function isMobileApp(env) {
  return env && env === 'mobile-app';
}

/***/ }),
/* 3 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* unused harmony export PREBID_EVENT */
/* unused harmony export AD_RENDER_SUCCEEDED */
/* unused harmony export AD_RENDER_FAILED */
/* harmony export (immutable) */ __webpack_exports__["a"] = prebidMessenger;
/* harmony export (immutable) */ __webpack_exports__["b"] = renderEventMessage;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__utils_js__ = __webpack_require__(0);
function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var PREBID_EVENT = 'Prebid Event';
var AD_RENDER_SUCCEEDED = 'adRenderSucceeded';
var AD_RENDER_FAILED = 'adRenderFailed';
function prebidMessenger(publisherURL) {
  var win = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : window;
  var prebidDomain = function () {
    if (publisherURL == null) {
      return null;
    }
    var parsedUrl = Object(__WEBPACK_IMPORTED_MODULE_0__utils_js__["f" /* parseUrl */])(publisherURL);
    return parsedUrl.protocol + '://' + parsedUrl.host;
  }();
  function isPrebidWindow(win) {
    return win && win.frames && win.frames.__pb_locator__;
  }
  var target = win.parent;
  try {
    while (target != null && target !== win.top && !isPrebidWindow(target)) {
      target = target.parent;
    }
    if (!isPrebidWindow(target)) target = win.parent;
  } catch (e) {}
  return function sendMessage(message, onResponse) {
    if (prebidDomain == null) {
      throw new Error('Missing pubUrl');
    }
    message = JSON.stringify(message);
    var messagePort;
    if (onResponse == null) {
      target.postMessage(message, prebidDomain);
    } else {
      var channel = new MessageChannel();
      messagePort = channel.port1;
      messagePort.onmessage = onResponse;
      win.addEventListener('message', windowListener);
      target.postMessage(message, prebidDomain, [channel.port2]);
    }
    return function stopListening() {
      if (messagePort != null) {
        win.removeEventListener('message', windowListener);
        messagePort.onmessage = null;
        messagePort = null;
      }
    };
    function windowListener(ev) {
      if ((ev.origin || ev.originalEvent && ev.originalEvent.origin) === prebidDomain) {
        onResponse(ev);
      }
    }
  };
}
function renderEventMessage(adId, errorInfo) {
  return _extends({
    adId: adId,
    message: PREBID_EVENT,
    event: errorInfo ? AD_RENDER_FAILED : AD_RENDER_SUCCEEDED
  }, errorInfo ? {
    info: errorInfo
  } : null);
}

/***/ }),
/* 4 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__utils__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__renderingManager__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__mobileAndAmpRender__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__environment__ = __webpack_require__(2);
/**
* legacy.js
* This is deprecated code, publishers should not use one .js creative to handle all different types of creative.
* To reduce bytes transfered for each ad, publishers should use specific .js based on hb_format targeting key-value.
*
* This file is inserted into the prebid creative as a placeholder for the winning prebid creative. It should support the following formats:
* - Banner
* - AMP
* - Mobile
* - Outstream Video
* - All safeFrame creatives
*/





window.ucTag = window.ucTag || {};
window.ucTag.renderAd = function (doc, dataObject) {
  var targetingData = Object(__WEBPACK_IMPORTED_MODULE_0__utils__["h" /* transformAuctionTargetingData */])(dataObject);
  if (Object(__WEBPACK_IMPORTED_MODULE_3__environment__["c" /* isMobileApp */])(targetingData.env) || Object(__WEBPACK_IMPORTED_MODULE_3__environment__["b" /* isAmp */])(targetingData.uuid, window)) {
    Object(__WEBPACK_IMPORTED_MODULE_2__mobileAndAmpRender__["a" /* renderAmpOrMobileAd */])(dataObject);
  } else {
    Object(__WEBPACK_IMPORTED_MODULE_1__renderingManager__["a" /* renderBannerOrDisplayAd */])(doc, dataObject);
  }
};

/***/ }),
/* 5 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["a"] = renderBannerOrDisplayAd;
/* unused harmony export renderLegacy */
/* unused harmony export renderCrossDomain */
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__utils__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__environment__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__domHelper__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__messaging_js__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__dynamicRenderer_js__ = __webpack_require__(6);





function renderBannerOrDisplayAd(doc, dataObject) {
  var targetingData = Object(__WEBPACK_IMPORTED_MODULE_0__utils__["h" /* transformAuctionTargetingData */])(dataObject);
  if (!Object(__WEBPACK_IMPORTED_MODULE_1__environment__["a" /* canLocatePrebid */])(window)) {
    renderCrossDomain(window, targetingData.adId, targetingData.adServerDomain, targetingData.pubUrl);
  } else {
    renderLegacy(doc, targetingData.adId);
  }
}

/**
 * Calls prebid.js renderAd function to render ad
 * @param {Object} doc Document
 * @param {string} adId Id of creative to render
 */
function renderLegacy(doc, adId) {
  var found = false;
  var w = window;
  for (var i = 0; i < 10; i++) {
    w = w.parent;
    if (w.pbjs) {
      try {
        w.pbjs.renderAd(doc, adId);
        found = true;
        break;
      } catch (e) {
        continue;
      }
    }
  }
  if (!found) {
    console.error("Unable to locate pbjs.renderAd function!");
  }
}

/**
 * Render ad in safeframe using postmessage
 * @param {string} adId Id of creative to render
 * @param {string} pubAdServerDomain publisher adserver domain name
 * @param {string} pubUrl Url of publisher page
 */
function renderCrossDomain(win, adId) {
  var pubAdServerDomain = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
  var pubUrl = arguments.length > 3 ? arguments[3] : undefined;
  var windowLocation = win.location;
  var adServerDomain = pubAdServerDomain || win.location.hostname;
  var fullAdServerDomain = windowLocation.protocol + '//' + adServerDomain;
  var sendMessage = Object(__WEBPACK_IMPORTED_MODULE_3__messaging_js__["a" /* prebidMessenger */])(pubUrl, win);
  var signalRenderResult = function signalRenderResult(errorInfo) {
    return sendMessage(Object(__WEBPACK_IMPORTED_MODULE_3__messaging_js__["b" /* renderEventMessage */])(adId, errorInfo));
  };
  function renderAd(ev) {
    var key = ev.message ? "message" : "data";
    var adObject = {};
    try {
      adObject = JSON.parse(ev[key]);
    } catch (e) {
      return;
    }
    if (adObject.message && adObject.message === "Prebid Response" && adObject.adId === adId) {
      if (Object(__WEBPACK_IMPORTED_MODULE_4__dynamicRenderer_js__["a" /* hasDynamicRenderer */])(adObject)) {
        Object(__WEBPACK_IMPORTED_MODULE_4__dynamicRenderer_js__["b" /* runDynamicRenderer */])(adId, adObject, sendMessage, win);
        return;
      }
      try {
        var body = win.document.body;
        var ad = adObject.ad;
        var url = adObject.adUrl;
        var width = adObject.width;
        var height = adObject.height;
        if (adObject.mediaType === "video") {
          signalRenderResult({
            reason: "preventWritingOnMainDocument",
            message: "Cannot render video ad ".concat(adId)
          });
          console.log("Error trying to write ad.");
        } else if (ad) {
          var iframe = Object(__WEBPACK_IMPORTED_MODULE_2__domHelper__["a" /* getEmptyIframe */])(adObject.height, adObject.width);
          body.appendChild(iframe);
          iframe.contentDocument.open();
          iframe.contentDocument.write(ad);
          iframe.contentDocument.close();
          signalRenderResult();
        } else if (url) {
          var _iframe = Object(__WEBPACK_IMPORTED_MODULE_2__domHelper__["a" /* getEmptyIframe */])(height, width);
          _iframe.style.display = "inline";
          _iframe.style.overflow = "hidden";
          _iframe.src = url;
          Object(__WEBPACK_IMPORTED_MODULE_2__domHelper__["b" /* insertElement */])(_iframe, document, "body");
          signalRenderResult();
        } else {
          signalRenderResult({
            reason: "noAd",
            message: "No ad for ".concat(adId)
          });
          console.log("Error trying to write ad. No ad markup or adUrl for ".concat(adId));
        }
      } catch (e) {
        signalRenderResult({
          reason: "exception",
          message: e.message
        });
        console.log("Error in rendering ad", e);
      }
    }
  }
  function requestAdFromPrebid() {
    var message = {
      message: 'Prebid Request',
      adId: adId,
      adServerDomain: fullAdServerDomain
    };
    sendMessage(message, renderAd);
  }
  requestAdFromPrebid();
}

/***/ }),
/* 6 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* unused harmony export MIN_RENDERER_VERSION */
/* harmony export (immutable) */ __webpack_exports__["a"] = hasDynamicRenderer;
/* harmony export (immutable) */ __webpack_exports__["b"] = runDynamicRenderer;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__domHelper_js__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__messaging_js__ = __webpack_require__(3);
function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }


var MIN_RENDERER_VERSION = 3;
function hasDynamicRenderer(message) {
  return typeof message.renderer === 'string' && parseInt(message.rendererVersion, 10) >= MIN_RENDERER_VERSION;
}
function runDynamicRenderer(adId, data, _sendMessage) {
  var win = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : window;
  var mkFrame = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : __WEBPACK_IMPORTED_MODULE_0__domHelper_js__["c" /* makeIframe */];
  var renderer = mkFrame(win.document, {
    width: 0,
    height: 0,
    style: 'display: none',
    srcdoc: "<script>".concat(data.renderer, "</script>"),
    name: '__pb_renderer__'
  });
  return new Promise(function (resolve, reject) {
    function onError() {
      var e = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      _sendMessage(Object(__WEBPACK_IMPORTED_MODULE_1__messaging_js__["b" /* renderEventMessage */])(adId, {
        reason: e.reason || 'exception',
        message: e.message
      }));
      e.stack && console.error(e);
      reject(e);
    }
    function guard(fn) {
      return function () {
        try {
          return fn.apply(this, arguments);
        } catch (e) {
          onError(e);
        }
      };
    }
    renderer.onload = guard(function () {
      var W = renderer.contentWindow;
      // NOTE: on Firefox, `Promise.resolve(P)` or `new Promise((resolve) => resolve(P))`
      // does not appear to work if P comes from another frame
      W.Promise.resolve(W.render(data, {
        mkFrame: mkFrame,
        sendMessage: function sendMessage(type, payload, onResponse) {
          return _sendMessage(_extends({
            adId: adId,
            message: type
          }, payload), onResponse ? guard(onResponse) : undefined);
        }
      }, win)).then(function () {
        return _sendMessage(Object(__WEBPACK_IMPORTED_MODULE_1__messaging_js__["b" /* renderEventMessage */])(adId));
      }, onError).then(resolve);
    });
    win.document.body.appendChild(renderer);
  });
}

/***/ }),
/* 7 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["a"] = renderAmpOrMobileAd;
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__utils__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__environment__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__domHelper__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__adHtmlRender__ = __webpack_require__(8);




var DEFAULT_CACHE_HOST = 'prebid.adnxs.com';
var DEFAULT_CACHE_PATH = '/pbc/v1/cache';

/**
 * Render mobile or amp ad
 * @param {string} cacheHost Cache host
 * @param {string} cachePath Cache path
 * @param {string} uuid id to render response from cache endpoint
 * @param {string} size size of the creative
 * @param {string} hbPb final price of the winning bid
 * @param {Bool} isMobileApp flag to detect mobile app
 */
function renderAmpOrMobileAd(dataObject) {
  var targetingData = Object(__WEBPACK_IMPORTED_MODULE_0__utils__["h" /* transformAuctionTargetingData */])(dataObject);
  var cacheHost = targetingData.cacheHost,
    cachePath = targetingData.cachePath,
    uuid = targetingData.uuid,
    size = targetingData.size,
    hbPb = targetingData.hbPb;
  uuid = uuid || '';
  // For MoPub, creative is stored in localStorage via SDK.
  var search = 'Prebid_';
  if (uuid.substr(0, search.length) === search) {
    loadFromLocalCache(uuid);
    //register creative right away to not miss initial geom-update
    updateIframe(size);
  } else {
    var adUrl = "".concat(getCacheEndpoint(cacheHost, cachePath), "?uuid=").concat(uuid);
    //register creative right away to not miss initial geom-update
    updateIframe(size);
    Object(__WEBPACK_IMPORTED_MODULE_0__utils__["g" /* sendRequest */])(adUrl, responseCallback(Object(__WEBPACK_IMPORTED_MODULE_1__environment__["c" /* isMobileApp */])(targetingData.env), hbPb));
  }
}

/**
 * Load response from localStorage. In case of MoPub, sdk caches response
 * @param {string} cacheId
 */
function loadFromLocalCache(cacheId) {
  var bid = window.localStorage.getItem(cacheId);
  var displayFn = responseCallback(true);
  displayFn(bid);
}

/**
 * update iframe by using size string to resize
 * @param {string} size
 */
function updateIframe(size) {
  if (size) {
    var sizeArr = size.split('x').map(Number);
    resizeIframe(sizeArr[0], sizeArr[1]);
  } else {
    console.log('Targeting key hb_size not found to resize creative');
  }
}

/**
 * Resize container iframe
 * @param {Number} width width of creative
 * @param {Number} height height of creative
 */
function resizeIframe(width, height) {
  var iframeWidth = window.innerWidth;
  var iframeHeight = window.innerHeight;
  if (iframeWidth !== width || iframeHeight !== height) {
    if (Object(__WEBPACK_IMPORTED_MODULE_1__environment__["d" /* isSafeFrame */])(window)) {
      var resize = function resize(status) {
        var newWidth = width - iframeWidth;
        var newHeight = height - iframeHeight;
        window.$sf.ext.expand({
          r: newWidth,
          b: newHeight,
          push: true
        });
      };
      window.$sf.ext.register(width, height, resize);
    }
    // AMP resize request in case the parent is AMP
    window.parent.postMessage({
      sentinel: 'amp',
      type: 'embed-size',
      width: width,
      height: height
    }, '*');
  }
}

/**
 * Returns cache endpoint concatenated with cache path
 * @param {string} cacheHost Cache Endpoint host
 * @param {string} cachePath Cache Endpoint path
 */
function getCacheEndpoint(cacheHost, cachePath) {
  var host = typeof cacheHost === 'undefined' || cacheHost === "" ? DEFAULT_CACHE_HOST : cacheHost;
  var path = typeof cachePath === 'undefined' || cachePath === "" ? DEFAULT_CACHE_PATH : cachePath;
  return "https://".concat(host).concat(path);
}

/**
 * Cache request Callback to display creative
 * @param {Bool} isMobileApp
 * @param {string} hbPb final price of the winning bid
 * @returns {function} a callback function that parses response
 */
function responseCallback(isMobileApp, hbPb) {
  return function (response) {
    var bidObject = parseResponse(response);
    var auctionPrice = bidObject.price || hbPb;
    var ad = Object(__WEBPACK_IMPORTED_MODULE_0__utils__["c" /* getCreativeCommentMarkup */])(bidObject);
    var width = bidObject.width ? bidObject.width : bidObject.w;
    var height = bidObject.height ? bidObject.height : bidObject.h;

    // When Prebid Universal Creative reads from Prebid Cache, we need to have it check for the existence of the wurl parameter. If it exists, hit it.
    if (bidObject.wurl) {
      Object(__WEBPACK_IMPORTED_MODULE_0__utils__["i" /* triggerPixel */])(decodeURIComponent(bidObject.wurl));
    }
    if (bidObject.adm) {
      if (auctionPrice) {
        // replace ${AUCTION_PRICE} macro with the bidObject.price or hb_pb.
        bidObject.adm = bidObject.adm.replace('${AUCTION_PRICE}', auctionPrice);
      } else {
        /*
          From OpenRTB spec 2.5: If the source value is an optional parameter that was not specified, the macro will simply be removed (i.e., replaced with a zero-length string).
         */
        bidObject.adm = bidObject.adm.replace('${AUCTION_PRICE}', '');
      }
      ad += isMobileApp ? constructMarkup(bidObject.adm, width, height) : bidObject.adm;
      if (bidObject.nurl) {
        ad += Object(__WEBPACK_IMPORTED_MODULE_0__utils__["a" /* createTrackPixelHtml */])(decodeURIComponent(bidObject.nurl));
      }
      if (bidObject.burl) {
        var triggerBurl = function triggerBurl() {
          Object(__WEBPACK_IMPORTED_MODULE_0__utils__["i" /* triggerPixel */])(bidObject.burl);
        };
        if (isMobileApp) {
          var mraidScript = Object(__WEBPACK_IMPORTED_MODULE_0__utils__["e" /* loadScript */])(window, 'mraid.js', function () {
            // Success loading MRAID
            var result = registerMRAIDViewableEvent(triggerBurl);
            if (!result) {
              triggerBurl(); // Error registering event
            }
          }, triggerBurl // Error loading MRAID
          );
        } else {
          triggerBurl(); // Not a mobile app
        }
      }

      Object(__WEBPACK_IMPORTED_MODULE_3__adHtmlRender__["a" /* writeAdHtml */])(ad);
    } else if (bidObject.nurl) {
      if (isMobileApp) {
        var adhtml = Object(__WEBPACK_IMPORTED_MODULE_0__utils__["e" /* loadScript */])(window, bidObject.nurl);
        ad += constructMarkup(adhtml.outerHTML, width, height);
        Object(__WEBPACK_IMPORTED_MODULE_3__adHtmlRender__["a" /* writeAdHtml */])(ad);
      } else {
        var nurl = bidObject.nurl;
        var commentElm = Object(__WEBPACK_IMPORTED_MODULE_0__utils__["b" /* getCreativeComment */])(bidObject);
        Object(__WEBPACK_IMPORTED_MODULE_2__domHelper__["b" /* insertElement */])(commentElm, document, 'body');
        Object(__WEBPACK_IMPORTED_MODULE_0__utils__["j" /* writeAdUrl */])(nurl, width, height);
      }
    }
  };
}
;

/**
 * Parse response
 * @param {string} response
 * @returns {Object} bidObject parsed response
 */
function parseResponse(response) {
  var bidObject;
  try {
    bidObject = JSON.parse(response);
  } catch (error) {
    console.log("Error parsing response from cache host: ".concat(error));
  }
  return bidObject;
}

/**
 * Wrap mobile app creative in div
 * @param {string} ad html for creative
 * @param {Number} width width of creative
 * @param {Number} height height of creative
 * @returns {string} creative markup
 */
function constructMarkup(ad, width, height) {
  var id = Object(__WEBPACK_IMPORTED_MODULE_0__utils__["d" /* getUUID */])();
  return "<div id=\"".concat(id, "\" style=\"border-style: none; position: absolute; width:100%; height:100%;\">\n      <div id=\"").concat(id, "_inner\" style=\"margin: 0 auto; width:").concat(width, "px; height:").concat(height, "px; position: absolute; top: 50%; left: 50%; transform: translate(-50%, -50%);\">").concat(ad, "</div>\n      </div>");
}
function registerMRAIDViewableEvent(callback) {
  function exposureChangeListener(exposure) {
    if (exposure > 0) {
      mraid.removeEventListener('exposureChange', exposureChangeListener);
      callback();
    }
  }
  function viewableChangeListener(viewable) {
    if (viewable) {
      mraid.removeEventListener('viewableChange', viewableChangeListener);
      callback();
    }
  }
  function registerViewableChecks() {
    if (window.MRAID_ENV && parseFloat(window.MRAID_ENV.version) >= 3) {
      mraid.addEventListener('exposureChange', exposureChangeListener);
    } else if (window.MRAID_ENV && parseFloat(window.MRAID_ENV.version) < 3) {
      if (mraid.isViewable()) {
        callback();
      } else {
        mraid.addEventListener('viewableChange', viewableChangeListener);
      }
    }
  }
  function readyListener() {
    mraid.removeEventListener('ready', readyListener);
    registerViewableChecks();
  }
  if (window.mraid && window.MRAID_ENV) {
    if (mraid.getState() == 'loading') {
      mraid.addEventListener('ready', readyListener);
    } else {
      registerViewableChecks();
    }
    return true;
  } else {
    return false;
  }
}

/***/ }),
/* 8 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["a"] = writeAdHtml;
function writeAdHtml(markup) {
  var insertHTML = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : appendToBody;
  // remove <?xml> and <!doctype> tags
  // https://github.com/prebid/prebid-universal-creative/issues/134
  markup = markup.replace(/\<(\?xml|(\!DOCTYPE[^\>\[]+(\[[^\]]+)?))+[^>]+\>/gi, '');
  insertHTML(markup);
}
function appendToBody(html) {
  try {
    var fragment = document.createRange().createContextualFragment(html);
    document.body.append(fragment);
  } catch (error) {
    console.error(error);
  }
}

/***/ })
/******/ ]);